HDU - 4810 Wall Painting【组合数+二进制拆分】

2024-01-17 00:38

本文主要是介绍HDU - 4810 Wall Painting【组合数+二进制拆分】,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

参看资料:

https://blog.csdn.net/xiaoyizhan139/article/details/82831533


题目:

Ms.Fang loves painting very much. She paints GFW(Great Funny Wall) every day. Every day before painting, she produces a wonderful color of pigments by mixing water and some bags of pigments. On the K-th day, she will select K specific bags of pigments and mix them to get a color of pigments which she will use that day. When she mixes a bag of pigments with color A and a bag of pigments with color B, she will get pigments with color A xor B. 
When she mixes two bags of pigments with the same color, she will get color zero for some strange reasons. Now, her husband Mr.Fang has no idea about which K bags of pigments Ms.Fang will select on the K-th day. He wonders the sum of the colors Ms.Fang will get with  different plans. 

For example, assume n = 3, K = 2 and three bags of pigments with color 2, 1, 2. She can get color 3, 3, 0 with 3 different plans. In this instance, the answer Mr.Fang wants to get on the second day is 3 + 3 + 0 = 6. 
Mr.Fang is so busy that he doesn’t want to spend too much time on it. Can you help him? 
You should tell Mr.Fang the answer from the first day to the n-th day.

Input

There are several test cases, please process till EOF. 
For each test case, the first line contains a single integer N(1 <= N <= 10 3).The second line contains N integers. The i-th integer represents the color of the pigments in the i-th bag.

Output

For each test case, output N integers in a line representing the answers(mod 10 6+3) from the first day to the n-th day.

Sample Input

4
1 2 10 1

Sample Output

14 36 30 8

 题目大意:

       给定n包颜料,第 i 天选取 i 种颜料,使这 i 种颜料相异或,求这一天所有可能的组合 异或后 的 和;

       输出从1到n天的结果;

解题思路:

       一开始没有看明白题意,后来明白题意了,一直想着分组暴力求解,想想实现不出来,,看了题解之后,了解了一种神奇的解题姿势,二进制拆分:以样例为例:

       二进制表示形式:

              1:  0 0 0 1

              2:  0 0 1 0

              10:1 0 1 0

              1:     0 0 0 1

       在第一位(就是二进制表示1的那一位)记录下来num[1]=2;

           第二位  num[2]=2;

           第三位  num[3]=0;

           第四位  num[4]=1;

       我们可以看出这四个是最大的是10,二进制位为4位。

       我们计算 1个数异或 和 就等于这四个数的和,我们也可以这样想:

       在第1位上是1的我们可以挑一个,在第1位是0的不挑这样就是四个数第1位1个数的异或和:

                                                 c(2,1)*c(2,0)*(1<<(1-1));

       第二位同样我们可以这样计算 :c(2,1)*c(2,0)*(1<<(2-1));

       第三位同样我们可以这样计算 :c(0,1)*c(4,0)*(1<<(3-1));、

       第四位同样我们可以这样计算 :c(1,1)*c(3,0)*(1<<(4-1));

       这四个结果加和即为一个数异或和的答案。

       而两个数异或和的答案就略微推广一点。很容易得知:因为我们要挑两个数,两个1或两个0异或和都是0;所以我们只有选择1个1和1个0;

       在第一位上这样计算:c(2,1)*c(2,1)*(1<<(1-1));

       第二位同样我们可以这样计算 :c(2,1)*c(2,1)*(1<<(2-1));

       第三位同样我们可以这样计算 :c(0,1)*c(4,1)*(1<<(3-1));、

       第四位同样我们可以这样计算 :c(1,1)*c(3,1)*(1<<(4-1));

       这四个结果和即为两个数异或和的答案。

       由此推广到n个数的异或和。

       因为数是int型,最大也就32位。所以时间复杂度为O(n*32*n/2);很快就算出答案。

代码实现:

#include <iostream>
#include <cstring>
#include <cstdio>
#include <algorithm>
#define inf 0x3f3f3f3f
#define maxn 1100
#define MOD 1000003
using namespace std;
int N;
long long rem[32],c[maxn][maxn];
//求1000以内的组合数,预处理
void init() {c[0][0] = c[1][0] = c[1][1] = 1;for (int i = 2; i < maxn; i++) {c[i][0] = 1;for (int j = 1; j <= i; j++)c[i][j] = (c[i-1][j] + c[i-1][j-1]) % MOD;}return ;
}
int main(){init();while(~scanf("%d",&N)){memset(rem,0,sizeof(rem));for(int i=0;i<N;i++){int k;scanf("%d",&k);for(int j=0;j<32;j++)//判断k的每一位是否为1if( (1<<j)& k ) rem[j]++;}for(int i=1;i<=N;i++){//n天累加long long ans=0;for(int j=0;j<32;j++){  //对于每一位上二进制累加for(int k=1;k<=rem[j] && k<=i;k+=2)//k+=2,找奇数个1,1,3,5....ans=(ans+ ( c[N-rem[j]][i-k]* (c[rem[j]][k]* ( (1<<j)%MOD) )%MOD)%MOD)%MOD;}if(i==N) printf("%I64d\n",ans);else     printf("%I64d ",ans);}}return 0;
}

 

 

 

 

 

 

 

 

 

 

这篇关于HDU - 4810 Wall Painting【组合数+二进制拆分】的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/614423

相关文章

hdu4869(逆元+求组合数)

//输入n,m,n表示翻牌的次数,m表示牌的数目,求经过n次操作后共有几种状态#include<iostream>#include<algorithm>#include<cstring>#include<stack>#include<queue>#include<set>#include<map>#include<stdio.h>#include<stdlib.h>#includ

usaco 1.3 Mixing Milk (结构体排序 qsort) and hdu 2020(sort)

到了这题学会了结构体排序 于是回去修改了 1.2 milking cows 的算法~ 结构体排序核心: 1.结构体定义 struct Milk{int price;int milks;}milk[5000]; 2.自定义的比较函数,若返回值为正,qsort 函数判定a>b ;为负,a<b;为0,a==b; int milkcmp(const void *va,c

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2093 考试排名(sscanf)

模拟题。 直接从教程里拉解析。 因为表格里的数据格式不统一。有时候有"()",有时候又没有。而它也不会给我们提示。 这种情况下,就只能它它们统一看作字符串来处理了。现在就请出我们的主角sscanf()! sscanf 语法: #include int sscanf( const char *buffer, const char *format, ... ); 函数sscanf()和

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

hdu 1754 I Hate It(线段树,单点更新,区间最值)

题意是求一个线段中的最大数。 线段树的模板题,试用了一下交大的模板。效率有点略低。 代码: #include <stdio.h>#include <string.h>#define TREE_SIZE (1 << (20))//const int TREE_SIZE = 200000 + 10;int max(int a, int b){return a > b ? a :

hdu 1166 敌兵布阵(树状数组 or 线段树)

题意是求一个线段的和,在线段上可以进行加减的修改。 树状数组的模板题。 代码: #include <stdio.h>#include <string.h>const int maxn = 50000 + 1;int c[maxn];int n;int lowbit(int x){return x & -x;}void add(int x, int num){while

hdu 3790 (单源最短路dijkstra)

题意: 每条边都有长度d 和花费p,给你起点s 终点t,要求输出起点到终点的最短距离及其花费,如果最短距离有多条路线,则输出花费最少的。 解析: 考察对dijkstra的理解。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstrin

hdu 2489 (dfs枚举 + prim)

题意: 对于一棵顶点和边都有权值的树,使用下面的等式来计算Ratio 给定一个n 个顶点的完全图及它所有顶点和边的权值,找到一个该图含有m 个顶点的子图,并且让这个子图的Ratio 值在所有m 个顶点的树中最小。 解析: 因为数据量不大,先用dfs枚举搭配出m个子节点,算出点和,然后套个prim算出边和,每次比较大小即可。 dfs没有写好,A的老泪纵横。 错在把index在d

hdu 1102 uva 10397(最小生成树prim)

hdu 1102: 题意: 给一个邻接矩阵,给一些村庄间已经修的路,问最小生成树。 解析: 把已经修的路的权值改为0,套个prim()。 注意prim 最外层循坏为n-1。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstri